/*
 *  endian.c: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include "unbind.h"


int endian(void)
{
  int i = 1;

  return (int)*(char*)&i;	/* little endian:1, big endian:0 */
}


unsigned short xshort(unsigned short in)
{
  return ((in & 0xff) << 8) | ((in >> 8) & 0xff);
}


void xshortp(unsigned short* inptr, unsigned short* outptr)
{
  ((unsigned char*)outptr)[0] = ((unsigned char*)inptr)[1];
  ((unsigned char*)outptr)[1] = ((unsigned char*)inptr)[0];
}


unsigned long  xlong(unsigned long in)
{
  return ((in & 0x000000ffUL) << 24) |
         ((in & 0x0000ff00UL) <<  8) |
         ((in & 0x00ff0000UL) >>  8) |
         ((in & 0xff000000UL) >> 24);
}


void xlongp(unsigned long* inptr, unsigned long* outptr)
{
  ((unsigned char*)outptr)[0] = ((unsigned char*)inptr)[3];
  ((unsigned char*)outptr)[1] = ((unsigned char*)inptr)[2];
  ((unsigned char*)outptr)[2] = ((unsigned char*)inptr)[1];
  ((unsigned char*)outptr)[3] = ((unsigned char*)inptr)[0];
}


