/*
 *  extract.c: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include <stdio.h>
#include "getopt.h"
#include "error.h"
#include "unbind.h"


static void extract_file(bind_s* root, char* file)
{
  FILE* fp;
  bind_s* bp;

  if ((bp = search_module(root, file)) == NULL) {
#ifdef	JMSG
    error("oCht@C %s Ƀt@C %s ͊܂܂Ă܂\n", bindfile, file);
#else
    error("file %s is not exist in bind_file %s", file, bindfile);
#endif
    return;
  }

  if ((fp = fopen(file, "wb")) == NULL) {
#ifdef	JMSG
    error("t@C %s 쐬ł܂\n", file);
#else
    error("cannnot create file %s", file);
#endif
  }

  if (f_verbose) {
#ifdef	JMSG
    fprintf(stderr, "t@C %-12s o... ", file);
#else
    fprintf(stderr, "extracting file %-12s... ", file);
#endif
    fflush(stderr);
  }

  /* oChItZbg */
  *(ulong*)(bp->body + BTAB_OFS) = 0UL;

  if (fwrite(bp->body, 1, bp->size, fp) != bp->size) {
#ifdef	JMSG
    error("t@C %s ߂܂\n", file);
#else
    error("cannnot write file %s", file);
#endif
  }

  fflush(fp);
#ifdef	HUMAN68K
  _dos_filedate(fileno(fp), (my_endian ? *(long*)&bp->btab->time
                                       : xlong(*(long*)&bp->btab->time)));
#else
  /*FIX ME*/;
#endif
  fclose(fp);
#ifdef	HUMAN68K
  _dos_chmod(file, bp->btab->attr);
#else
  /*FIX ME*/;
#endif

  if (f_verbose) {
#ifdef	JMSG
    fputs("I\n", stderr);
#else
    fputs("done\n", stderr);
#endif
  }
}


void extract(bind_s* root, int ac, char** av)
{
  char    buf[32];
  bind_s* bp;

  if (f_all) {
    for (bp = root; bp; bp = bp->next) {
      extract_file(root, dosname2filename(bp->btab, buf));
    }
  }
  else {
    while (ac > optind) {
      extract_file(root, av[optind++]);
    }
  }
}


